define(['common', 'config'], function(com, con) {

	var pageIds = ['#province', '#city', '#county', '#street'];
	var data = {
		province: "",
		provincename: "",
		city: "",
		cityname: "",
		county: "",
		countyname: "",
		town: "",
		townname: "",
		levelno: "",
		paytype: "",
	};

	//初始化单页view
	var viewApi = mui('#app').view({
		defaultPage: pageIds[0]
	});
	var view = viewApi.view;
	(function(mui) {

		//处理view的后退与webview后退
		var oldBack = mui.back;
		mui.back = function() {
			if(viewApi.canBack()) { //如果view可以后退，则执行view的后退
				viewApi.back();
			} else { //执行webview后退
				oldBack();
			}
		};

	})(mui);

	return {
		init: function() {
			var my = this;
			my.getAreaList();
			//点击进入后下级目录是否显示
			$(".mui-table-view").on('tap', '.txttown', function() {
				var level = parseInt($(this).parent().attr('data-level'));
				var key = $(this).parent().attr('data-key');
				var name = $(this).parent().attr('data-text');
				var last = $(this).parent().attr('data-last');
				if(level == "1") {
					data.province = key;
					data.provincename = name;
				} else if(level == "2") {
					data.city = key;
					data.cityname = name;

				} else if(level == "3") {
					data.county = key;
					data.countyname = name;

				} else if(level == "4") {
					data.town = key;
					data.townname = name;
				}
				if(last == 'null') {
					var parentId = pageIds[level];
					var jqObj = $(parentId);
					jqObj.find(".mui-table-view").html("");
					com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
						parentCode: key
					}, function(data) {
						if(data.result) {
							$.each(data.data, function(idx, item) {
								jqObj.find(".mui-table-view")
									.append(jqObj.find(".template").html().replaceAll("{Text}", item.DivisionName)
										.replaceAll("{Value}", item.DivisionCode)
										.replaceAll("{DivisionGrade}", item.DivisionGrade)
										.replaceAll("{ParentCode}", item.ParentCode)
										.replaceAll("{last}", item.IsLast));
							});
						}
					});
				} else {
					if(com.isWx()) {
						com.dataCom.set("ZZAreaData", JSON.stringify(data));
						setTimeout(function() {
							com.open(con.urlCONFIG.pay.url.upmemberlevel);
						}, 200);
					} else {
						var page = plus.webview.currentWebview().opener();
						if(page) {
							//console.log(JSON.stringify(data));
							page.evalJS("page_callback('" + JSON.stringify(data) + "')");
							com.close();
						}

					}

				}

			});

		},

		getAreaList: function() {
			var jqObj = $("#province");
			jqObj.find(".mui-table-view").html("");
			com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
				parentCode: '156'
			}, function(data) {
				if(data.result) {
					$.each(data.data, function(idx, item) {
						jqObj.find(".mui-table-view").append(jqObj.find(".template").html()
							.replaceAll("{Text}", item.DivisionName)
							.replaceAll("{Value}", item.DivisionCode)
							.replaceAll("{DivisionGrade}", item.DivisionGrade)
							.replaceAll("{ParentCode}", item.ParentCode)
							.replaceAll("{last}", item.IsLast))
					})
				}
			});
		},

		familyarea: {
			init: function() {
				var my = this;
				my.getAreaList();
				//点击进入后下级目录是否显示
				$(".mui-table-view").on('tap', '.txttown', function() {
					var level = parseInt($(this).parent().attr('data-level'));
					var key = $(this).parent().attr('data-key');
					var name = $(this).parent().attr('data-text');
					var last = $(this).parent().attr('data-last');
					if(level == "1") {
						data.province = key;
						data.provincename = name;
					} else if(level == "2") {
						data.city = key;
						data.cityname = name;

					} else if(level == "3") {
						data.county = key;
						data.countyname = name;

					} else if(level == "4") {
						data.town = key;
						data.townname = name;
					}
					if(last == 'null') {
						var parentId = pageIds[level];
						var jqObj = $(parentId);
						jqObj.find(".mui-table-view").html("");
						com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
							parentCode: key
						}, function(data) {
							if(data.result) {
								$.each(data.data, function(idx, item) {
									jqObj.find(".mui-table-view")
										.append(jqObj.find(".template").html().replaceAll("{Text}", item.DivisionName)
											.replaceAll("{Value}", item.DivisionCode)
											.replaceAll("{DivisionGrade}", item.DivisionGrade)
											.replaceAll("{ParentCode}", item.ParentCode)
											.replaceAll("{last}", item.IsLast));
								});
							}
						});
					} else {
						mui.plusReady(function() {
							var page = plus.webview.currentWebview().opener();
							if(page) {
								page.evalJS("page_callback('" + JSON.stringify(data) + "')");
								com.close();
							}
						});
					}

				});

			},

			getAreaList: function() {
				var jqObj = $("#province");
				jqObj.find(".mui-table-view").html("");
				com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
					parentCode: '156'
				}, function(data) {
					if(data.result) {
						$.each(data.data, function(idx, item) {
							jqObj.find(".mui-table-view").append(jqObj.find(".template").html()
								.replaceAll("{Text}", item.DivisionName)
								.replaceAll("{Value}", item.DivisionCode)
								.replaceAll("{DivisionGrade}", item.DivisionGrade)
								.replaceAll("{ParentCode}", item.ParentCode)
								.replaceAll("{last}", item.IsLast))
						})
					}
				});
			},

		},

		town: {
			init: function() {
				var my = this;
				my.getAreaList();
				//点击进入后下级目录是否显示
				$(".mui-table-view").on('tap', '.txttown', function() {
					var level = parseInt($(this).parent().attr('data-level'));
					var key = $(this).parent().attr('data-key');
					var name = $(this).parent().attr('data-text');
					var last = $(this).parent().attr('data-last');
					if(level == "1") {
						data.select = "Province";
						data.province = key;
						data.provincename = name;
					} else if(level == "2") {
						data.select = "City";
						data.city = key;
						data.cityname = name;

					} else if(level == "3") {
						data.select = "County";
						data.county = key;
						data.countyname = name;

					} else if(level == "4") {
						data.select = "Town";
						data.town = key;
						data.townname = name;
					}
					data.value = key;
					data.text = name;
					var parentId = pageIds[level];
					var jqObj = $(parentId);
					jqObj.find(".mui-table-view").html("");
					if(last == 'null') {
						var url = "";
						var postdata = {};
						if(parentId == "#street") {
							url = con.urlCONFIG.account.api.api_GetAreaByParentCode;
							postdata = {
								parentCode: key,
								select: "Town"
							};
						} else {
							url = con.urlCONFIG.account.api.api_GetAdministrativeArea;
							postdata = {
								parentCode: key
							};
						}
						com.get(url, postdata, function(data) {
							if(data.result) {
								$.each(data.data, function(idx, item) {
									jqObj.find(".mui-table-view")
										.append(jqObj.find(".template").html().replaceAll("{Text}", item.DivisionName)
											.replaceAll("{Value}", item.DivisionCode)
											.replaceAll("{DivisionGrade}", item.DivisionGrade)
											.replaceAll("{ParentCode}", item.ParentCode)
											.replaceAll("{last}", item.IsLast));
								});
							}
						});
					} else {
						if(com.isWx()) {
							com.dataCom.set("ZZAreaData", JSON.stringify(data));
							setTimeout(function() {
								com.open(con.urlCONFIG.pay.url.url_zhanzhangtype);
							}, 200);
						} else {
							var page = plus.webview.currentWebview().opener();
							if(page) {
								//console.log(JSON.stringify(data));
								page.evalJS("page_callback('" + JSON.stringify(data) + "')");
								com.close();
							}

						}

					}

				});

			},

			getAreaList: function() {
				var jqObj = $("#province");
				jqObj.find(".mui-table-view").html("");
				com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
					parentCode: '156'
				}, function(data) {
					if(data.result) {
						$.each(data.data, function(idx, item) {
							jqObj.find(".mui-table-view").append(jqObj.find(".template").html()
								.replaceAll("{Text}", item.DivisionName)
								.replaceAll("{Value}", item.DivisionCode)
								.replaceAll("{DivisionGrade}", item.DivisionGrade)
								.replaceAll("{ParentCode}", item.ParentCode)
								.replaceAll("{last}", item.IsLast))
						})
					}
				});
			},
		},

		county: {
			init: function() {
				var my = this;
				my.getAreaList();
				//点击进入后下级目录是否显示
				$(".mui-table-view").on('tap', '.txttown', function() {
					var level = parseInt($(this).parent().attr('data-level'));
					var key = $(this).parent().attr('data-key');
					var name = $(this).parent().attr('data-text');
					var last = $(this).parent().attr('data-last');
					if(level == "1") {
						data.province = key;
						data.provincename = name;
					} else if(level == "2") {
						data.city = key;
						data.cityname = name;
					} else if(level == "3") {
						data.select = "County";
						data.county = key;
						data.countyname = name;

					}
					data.value = key;
					data.text = name;
					var parentId = pageIds[level];
					var jqObj = $(parentId);
					jqObj.find(".mui-table-view").html("");
					var url = "";
					var postdata = {};
					if(level != '3') {
						if(parentId == "#county") {
							url = con.urlCONFIG.account.api.api_GetAreaByParentCode;
							postdata = {
								parentCode: key,
								select: "County"
							};
						} else {
							url = con.urlCONFIG.account.api.api_GetAdministrativeArea;
							postdata = {
								parentCode: key
							};
						}
						com.get(url, postdata, function(data) {
							if(data.result) {
								$.each(data.data, function(idx, item) {
									jqObj.find(".mui-table-view")
										.append(jqObj.find(".template").html().replaceAll("{Text}", item.DivisionName)
											.replaceAll("{Value}", item.DivisionCode)
											.replaceAll("{DivisionGrade}", item.DivisionGrade)
											.replaceAll("{ParentCode}", item.ParentCode)
											.replaceAll("{last}", item.IsLast));
								});
							}
						});
					} else {
						if(com.isWx()) {
							com.dataCom.set("ZZAreaData", JSON.stringify(data));
							setTimeout(function() {
								com.open(con.urlCONFIG.pay.url.url_zhanzhangtype);
							}, 500);
						} else {
							var page = plus.webview.currentWebview().opener();
							if(page) {
								//console.log(JSON.stringify(data));
								page.evalJS("page_callback('" + JSON.stringify(data) + "')");
								com.close();
							}

						}

					}

				});

			},

			getAreaList: function() {
				var jqObj = $("#province");
				jqObj.find(".mui-table-view").html("");
				com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
					parentCode: '156'
				}, function(data) {
					if(data.result) {
						$.each(data.data, function(idx, item) {
							jqObj.find(".mui-table-view").append(jqObj.find(".template").html()
								.replaceAll("{Text}", item.DivisionName)
								.replaceAll("{Value}", item.DivisionCode)
								.replaceAll("{DivisionGrade}", item.DivisionGrade)
								.replaceAll("{ParentCode}", item.ParentCode)
								.replaceAll("{last}", item.IsLast))
						})
					}
				});
			},
		},

		city: {
			init: function() {
				var my = this;
				my.getAreaList();
				//点击进入后下级目录是否显示
				$(".mui-table-view").on('tap', '.txttown', function() {
					var level = parseInt($(this).parent().attr('data-level'));
					var key = $(this).parent().attr('data-key');
					var name = $(this).parent().attr('data-text');
					var last = $(this).parent().attr('data-last');
					if(level == "1") {
						data.province = key;
						data.provincename = name;
					}
					if(level == "2") {
						data.select = "City";
						data.city = key;
						data.cityname = name;

					}
					data.value = key;
					data.text = name;
					var parentId = pageIds[level];
					var jqObj = $(parentId);
					jqObj.find(".mui-table-view").html("");
					var url = "";
					var postdata = {};
					if(level != '2') {

						if(parentId == "#city") {
							url = con.urlCONFIG.account.api.api_GetAreaByParentCode;
							postdata = {
								parentCode: key,
								select: "City"
							};
						} else {
							url = con.urlCONFIG.account.api.api_GetAdministrativeArea;
							postdata = {
								parentCode: key
							};
						}
						com.get(url, postdata, function(data) {
							if(data.result) {
								$.each(data.data, function(idx, item) {
									jqObj.find(".mui-table-view")
										.append(jqObj.find(".template").html().replaceAll("{Text}", item.DivisionName)
											.replaceAll("{Value}", item.DivisionCode)
											.replaceAll("{DivisionGrade}", item.DivisionGrade)
											.replaceAll("{ParentCode}", item.ParentCode)
											.replaceAll("{last}", item.IsLast));
								});
							}
						});
					} else {
						if(com.isWx()) {
							com.dataCom.set("ZZAreaData", JSON.stringify(data));
							setTimeout(function() {
								com.open(con.urlCONFIG.pay.url.url_zhanzhangtype);
							}, 200);
						} else {
							var page = plus.webview.currentWebview().opener();
							if(page) {
								//console.log(JSON.stringify(data));
								page.evalJS("page_callback('" + JSON.stringify(data) + "')");
								com.close();
							}

						}

					}

				});

			},

			getAreaList: function() {
				var jqObj = $("#province");
				jqObj.find(".mui-table-view").html("");
				com.get(con.urlCONFIG.account.api.api_GetAdministrativeArea, {
					parentCode: '156'
				}, function(data) {
					if(data.result) {
						$.each(data.data, function(idx, item) {
							jqObj.find(".mui-table-view").append(jqObj.find(".template").html()
								.replaceAll("{Text}", item.DivisionName)
								.replaceAll("{Value}", item.DivisionCode)
								.replaceAll("{DivisionGrade}", item.DivisionGrade)
								.replaceAll("{ParentCode}", item.ParentCode)
								.replaceAll("{last}", item.IsLast))
						})
					}
				});
			},
		},

		province: {
			init: function() {
				var my = this;
				my.getAreaList();
				//点击进入后下级目录是否显示
				$(".mui-table-view").on('tap', '.txttown', function() {
					var level = parseInt($(this).parent().attr('data-level'));
					var key = $(this).parent().attr('data-key');
					var name = $(this).parent().attr('data-text');
					var last = $(this).parent().attr('data-last');
					if(level == "1") {
						data.province = key;
						data.provincename = name;
						select: "Province"
					}
					data.value = key;
					data.text = name;
					data.select = "Province";
					if(com.isWx()) {
						com.dataCom.set("ZZAreaData", JSON.stringify(data));
						setTimeout(function() {
							com.open(con.urlCONFIG.pay.url.url_zhanzhangtype);
						}, 200);

					} else {
						var page = plus.webview.currentWebview().opener();
						if(page) {
							page.evalJS("page_callback('" + JSON.stringify(data) + "')");
							com.close();
						}
					}
				});
			},

			getAreaList: function() {
				var jqObj = $("#province");
				jqObj.find(".mui-table-view").html("");
				com.get(con.urlCONFIG.account.api.api_GetAreaByParentCode, {
					parentCode: '156',
					select: "Province"
				}, function(data) {
					if(data.result) {
						$.each(data.data, function(idx, item) {
							jqObj.find(".mui-table-view").append(jqObj.find(".template").html()
								.replaceAll("{Text}", item.DivisionName)
								.replaceAll("{Value}", item.DivisionCode)
								.replaceAll("{DivisionGrade}", item.DivisionGrade)
								.replaceAll("{ParentCode}", item.ParentCode)
								.replaceAll("{last}", item.IsLast))
						})
					}
				});
			},
		},

	}
});