define(['common', 'config'], function(com, config) {
	//model对象
	_model = {
		result: true,
		id: 0,
		PhotoAddress: "",
		PhotoPath: "",
		PhotoAddressTh: "",
		PhotoPathTh: ""
	};

	//记录上传文件数
	upTimer = {
		count: 0,
		imgs: [],
		currentSendCount: 0,
		selectedCount: 0,
	};
	//压缩（需要获取本地文件权限）
	function resize(src, callback) {
		var filename = src.substring(src.lastIndexOf('/') + 1);
		plus.zip.compressImage({
				src: src,
				dst: '_doc/' + filename,
				overwrite: true,
				width: '450px', //这里指定了宽度，同样可以修改
				format: 'jpg',
				quality: 90 //图片质量不再修改，以免失真
			},
			function(e) {

				callback(e.target);
			},
			function(err) {
				com.alert('未知错误!', 2, function() {
					mui.back();
				})
			})
	};

	//压缩
	function zipCompressFile(src, callback) {
		console.log("压缩");
		var zipfile = src.substr(0, src.lastIndexOf('.')) + ".zip";
		console.log(zipfile);
		plus.zip.compress(src, zipfile,
			function(e) {
				console.log("压缩完成");
				console.log(JSON.stringify(e));
				console.log(e);
				callback(zipfile);
			},
			function(error) {
				if(error.message == "文件存在") {
					callback(zipfile);
				} else {
					console.log(JSON.stringify(error));
					com.alert('未知错误!', 2, function() {
						mui.back();
					});
				}

			});
	}

	function deleteFile(path) {
		var File = plus.android.importClass("java.io.File");
		var fd = new File(path);
		if(fd != null && fd.exists()) {
			fd.delete();
			plus.nativeUI.toast("删除成功");
		}
	}
	/*
	 * 打开摄像头、打开图库 模块
	 */
	return {
		//普通上传图片
		normal: {
			//拍照
			getImage: function(type, callback) {
				this.shotImage({
					type: type,
					callback: callback
				});
			},
			//打开相册
			galleryImg: function(type, ismultiple, imgcount, callback, onStateChanged) {
				this.uploadImage({
					type: type,
					ismultiple: ismultiple,
					imgcount: imgcount,
					callback: callback,
					onStateChanged: onStateChanged
				});
			},
			//拍摄照片
			shotImage: function(options) {
				//默认参数
				var op = $.extend({
					url: config.urlCONFIG.common.api.api_FileUpload_UpLoadProcessImg,
					type: "",
					callback: null,
					onStateChanged: null,
				}, options);

				var my = this;
				mui.plusReady(function() {
					var data = {
						result: false,
						msg: '',
						data: null
					};
					var c = plus.camera.getCamera();

					c.captureImage(function(e) { 
						plus.io.resolveLocalFileSystemURL(e, function(entry) {
							var s = entry.toLocalURL();
							data.result = true;
							data.data = s;
							op.filepath = s;
							my.postImage(op);
						}, function(e) {
							data.data = "读取拍照文件错误：" + e.message;
							callback(data);
						});
					}, function(error) {
						console.log("拍照异常"); 
						data.msg = error.message;
					})
				});
			},
			uploadImage: function(options) {
				//默认参数
				var op = $.extend({
					url: config.urlCONFIG.common.api.api_FileUpload_UpLoadProcessImg,
					type: "",
					ismultiple: false,
					imgcount: 0,
					callback: null,
					onStateChanged: null,
				}, options);

				var my = this;
				upTimer.currentSendCount = 0;
				var mu = {};
				
				if(op.ismultiple) {		
					var maximum=9 - op.imgcount;
					mu = {
						filter: "image",
						multiple: true,
						maximum:maximum,
						system:false
					};
				} else {
					mu = {
						filter: "image"
					}
				}
				plus.gallery.pick(function(a) {
					if(op.ismultiple) {
						upTimer.selectedCount = a.files.length;
						$.each(a.files, function(index, item) {
							op.filepath = item;
							my.postImage(op);
						});
					} else {
						upTimer.selectedCount = 1;
						op.filepath = a;
						my.postImage(op);
					}

				}, function(e) {
					console.log("上传异常" + JSON.stringify(e));
				},mu);
			},
			//上传图片到服务器
			postImage: function(options) {
				var op = $.extend({
					url: "",
					type: "",
					filepath: null,
					callback: null,
					onStateChanged: null,
				}, options);

				var my = this;
				upTimer.count++;
				upTimer.currentSendCount = upTimer.currentSendCount + 1;
				//var tips = com.tips(upTimer.count + '个文件正在上传', 999);
				mui.plusReady(function() {
					var task = plus.uploader.createUpload(op.url, {
							method: "POST",
							blocksize: 0,
							priority: 100
						},
						function(t, status) {
							console.log(t.responseText);
							var data = JSON.parse(t.responseText);
							if(data.result) {
								// 上传完成
								if(status == 200) {
									upTimer.count--;
									var model = _.clone(_model);
									model.id = new Date().getTime();
									model.PhotoAddress = data.data.url;
									model.PhotoPath = data.data.path;
									model.PhotoAddressTh = data.data.thurl;
									model.PhotoPathTh = data.data.thpath;
									model.IsLast = (upTimer.count <= 0);
									upTimer.imgs.push(model);
									if(op.callback) {
										op.callback(model);
									}

									if(op.onStateChanged) {
										var percentData = upTimer.currentSendCount * 100 / upTimer.selectedCount;
										op.onStateChanged({
											status: 3,
											precent: percentData.toFixed(2),
											message: "正在上传中"
										});
									}
								}
							} else {
								op.callback(data);
								if(op.onStateChanged) {
									op.onStateChanged({
										status: 4,
										precent: percentData.toFixed(2),
										message: "上传完成"
									});
								}
							}
						}
						//						else{
						//							com.tips('上传失败：' + data.msg, 0);
						//						}
					);
					if(op.onStateChanged) {
						op.onStateChanged({
							status: 2,
							precent: 0,
							message: "开始上传"
						});
					}

					//图片压缩
					resize(op.filepath, function(zipSrc) {
						task.addFile(zipSrc, {
							key: "file"
						});
						task.addData(zipSrc, zipSrc);
						task.addData("width", op.width || 100);
						task.addData("height", op.height || 100);
						task.addData("uppath", op.type);
						task.start();
					});
				});
			},
		},
		camera: {
			//			拍摄上传视频
			//			url: config.urlCONFIG.common.api.api_FileUpload_UpLoadProcess, //上传地址
			//			type: "", //服务器存储文件 或特定类型
			//			compress: false, //是否压缩
			//			callback: null,  //上传回调
			//			onStateChanged: null //进度回调
			getMaxPixel: function(pixelList) {
				var maxPixel = "";
				var maxWidth = 0;
				var width = 0;
				$.each(pixelList, function(i, item) {
					var rideIndex = item.indexOf("*");
					if(rideIndex > 0) {
						width = parseInt(item.substr(0, rideIndex)); 
						if(width > maxWidth) {
							maxPixel = item;
							maxWidth = width;							
						}
					}
				});
				if(maxPixel == "") {
					if(com.isIOS) {
						return pixelList[1];
					} else {
						return pixelList[0];
					}
				} else {
					return maxPixel;
				}
			},
			shotVideo: function(options) {
				//默认参数
				var op = $.extend({
					url: config.urlCONFIG.common.api.api_FileUpload_UpLoadProcess,
					type: "",
					compress: false,
					callback: null,
					onStateChanged: null,
				}, options);

				var my = this;
				mui.plusReady(function() {
					var cmr = plus.camera.getCamera();
					 
					var res =my.getMaxPixel(cmr.supportedVideoResolutions); 
					cmr.startVideoCapture(function(p) {
						plus.io.resolveLocalFileSystemURL(p, function(entry) {
							var filepath = entry.toLocalURL(p);
							op.filename = entry.name;
							//							entry.file(function(file) { 
							//							});
							//							
							op.filepath = filepath;
							my.postVideo(op);
						}, function(e) {
							console.log('读取录像文件错误：' + e.message);
						});
					}, function(e) {
						console.log('失败：' + e.message);
					}, {
						filename: '_doc/',
						index: 1,
						resolution: res
					});
				});
			},

			uploadVideo: function(options) {
				var op = $.extend({
					url: config.urlCONFIG.common.api.api_FileUpload_UpLoadProcess,
					type: "",
					compress: false,
					callback: null,
					onStateChanged: null
				}, options);
				var my = this;
				plus.gallery.pick(function(p) {
					console.log("获取路径" + p);
					plus.io.resolveLocalFileSystemURL(p, function(entry) {
						var filepath = entry.toLocalURL(p);
						op.filename = entry.name;
						entry.file(function(file) {

							console.log(JSON.stringify(file));

							//							if(file.size > 10485760) {
							//								com.tips("请选择10M以下的文件");
							//							} else 

							var reg = /\.mov$/;
							if(com.isIOS && reg.test(filepath)) {
								if(op.onStateChanged) {
									op.onStateChanged({
										status: 1,
										precent: 0,
										message: "正在压缩数据"
									});
								}
								zipCompressFile(filepath, function(zipfile) {
									op.filepath = zipfile;
									op.compress = true;
									my.postVideo(op);
								});
							} else {
								op.filepath = filepath;
								my.postVideo(op);
							}
						});

					}, function(e) {
						console.log('读取录像文件错误：' + e.message);
					});
				}, function(e) {
					console.log("异常");
					console.log(JSON.stringify(e));
				}, {
					filter: "video"
				});
			}, //			选择上传视频
			postVideo: function(options) {
				var op = $.extend({
					url: "",
					filepath: null,
					filename: null,
					type: "",
					compress: false,
					callback: null,
					onStateChanged: null,
					width: "300",
					height: "300"
				}, options);

				var task = plus.uploader.createUpload(op.url, {
						method: "POST",
						blocksize: 0,
						priority: 100
					},
					function(t, status) {
						var reg = /\.zip$/;
						if(com.isIOS && reg.test(op.filename)) {
							console.log("删除文件");
						}
						if(t.responseText) {
							var data = JSON.parse(t.responseText);
							if(data && data.error == 0) {
								data.result = true;
								op.callback(data);
							}
						}
						if(op.onStateChanged) {
							op.onStateChanged({
								status: 4,
								precent: 100,
								message: "上传完成"
							});
						}
						console.log(t.responseText);
					}
				);
				task.addEventListener("statechanged", function(upload, status) {
					if(upload.state == 3) {
						var percentData = upload.uploadedSize * 100 / upload.totalSize;
						if(percentData >= 100) {
							percentData = 99.99;
						}
						if(op.onStateChanged) {
							op.onStateChanged({
								status: 3,
								precent: percentData.toFixed(2),
								message: "正在上传中"
							});
						}
					}
				}, false);
				task.addFile(op.filepath, {
					key: op.filename
				});

				task.addData("width", op.width || 300);
				task.addData("height", op.height || 300);
				task.addData("uppath", op.type);
				if(op.compress) {
					task.addData("compress", "true");
					task.addData("filename", op.filename);
				}
				if(op.onStateChanged) {
					op.onStateChanged({
						status: 2,
						precent: 0,
						message: "开始上传"
					});
				}
				task.start();
			},
		} //	上传视频

	};
})