define(['common'], function(com) {
	/*
	 * GPS定位模块
	 */
	return {
		/**
		 * @constructor
		 * @description 得到定位信息
		 */
		getlocation: function(callback) {
			mui.plusReady(function() {
				var data = {
					result: false,
					code: '',
					msg: '',
					position: null
				};
				plus.geolocation.getCurrentPosition(function(p) {
					//debugCom.log(JSON.stringify(p))
					data.result = true;
					data.position = p;
					data.code = 0;
					data.msg = '';
					//回调			
					callback(data);
				}, function(e) {
					console.log(JSON.stringify(e))
					data.result = false;
					data.code = e.code;
					switch(e.code) {
						case 1:
							data.msg = "GPS访问被拒绝 或 GPS未开启";
							break;
						case 2:
							data.msg = "位置信息不可用";
							break;
						case 3:
							data.msg = "获取用户位置的请求超时";
							break;
						default:
							data.msg = e.message;
							break;
					}
					if(data.msg == '')
						data.msg = "获取用户位置的请求超时";
					//回调
					callback(data);
				}, {
					provider: 'amap'
				});
				/*
				 provider: (String 类型 )优先使用的定位模块可取以下供应者： "system"：表示系统定位模块，支持wgs84坐标系； "baidu"：表示百度定位模块，支持gcj02/bd09/bd09ll坐标系； "amap"：表示高德定位模板，支持gcj02坐标系。 默认值按以下优先顺序获取（amap>baidu>system），若指定的provider不存在或无效则返回错误回调。 注意：百度/高德定位模块需要配置百度/高德地图相关参数才能正常使用。
				 * */
			});
		},
		/**
		 * @constructor
		 * @description 得到地址
		 */
		getaddress: function(callback) {
			gps.getlocation(function(data) {
				var resdata = {
					result: false,
					msg: '',
					data: ''
				}
				if(data.result) {
					resdata.result = true;
					resdata.data = (data.position.address.poiName ? data.position.address.poiName : data.position.addresses);
					callback(resdata);
				} else {
					resdata.msg = data.msg;
					callback(resdata);
				}
			})
		}
	};
});