define(['common', 'config'], function(com, config) {

	return {
		conn: null,
		from: null,
		messagetype: "chat", //聊天模式 chat/groupchat
		onTextMessage: null,
		getNowFormatDate: function() {
			var date = new Date();
			var seperator1 = "-";
			var seperator2 = ":";
			var month = date.getMonth() + 1;
			var strDate = date.getDate();
			if(month >= 1 && month <= 9) {
				month = "0" + month;
			}
			if(strDate >= 0 && strDate <= 9) {
				strDate = "0" + strDate;
			}
			var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate +
				" " + date.getHours() + seperator2 + date.getMinutes() +
				seperator2 + date.getSeconds();
			return currentdate;
		},
		toShowTimeString: function(time) {
			try {
				var nowdate = new Date();
				var timedate = new Date(time);
				var year = timedate.getFullYear();
				var month = timedate.getMonth() + 1;
				var day = timedate.getDate();
				if(year == nowdate.getFullYear() && month == nowdate.getMonth() + 1) {
					if(day == nowdate.getDate()) {
						return date.getHours() + ":" + date.getMinutes();
					} else if(day + 1 == nowdate.getDate()) {
						return "昨天";
					}
				} 
				return year + "-" + (month < 10 ? ("0" + month) : month) + "-" + (day < 10 ? ("0" + day) : day);
				
			} catch(e) {
				return "异常";
			}
		},
		dataURL2Audio: function(base64Str, callback) {
			var base64Str = base64Str.replace('data:audio/amr;base64,', '');
			var audioName = (new Date()).valueOf() + '.amr';
			plus.io.requestFileSystem(plus.io.PRIVATE_DOC, function(fs) {
				fs.root.getFile(audioName, {
					create: true
				}, function(entry) {
					// 获得平台绝对路径
					var fullPath = entry.fullPath;
					if(mui.os.android) {
						// 读取音频
						var Base64 = plus.android.importClass("android.util.Base64");
						var FileOutputStream = plus.android.importClass("java.io.FileOutputStream");
						try {
							var out = new FileOutputStream(fullPath);
							var bytes = Base64.decode(base64Str, Base64.DEFAULT);
							out.write(bytes);
							out.close();
							// 回调
							callback && callback(entry);
						} catch(e) {
							console.log(e.message);
						}
					} else if(mui.os.ios) {
						var NSData = plus.ios.importClass('NSData');
						var nsData = new NSData();
						nsData = nsData.initWithBase64EncodedStringoptions(base64Str, 0);
						if(nsData) {
							nsData.plusCallMethod({
								writeToFile: fullPath,
								atomically: true
							});
							plus.ios.deleteObject(nsData);
						}
						// 回调
						callback && callback(entry);
					}
				})
			})
		},
		connection: function() {
			var my = this;
			my.conn = new WebIM.connection({
				https: WebIM.config.https,
				url: WebIM.config.xmppURL,
				isAutoLogin: WebIM.config.isAutoLogin,
				isMultiLoginSessions: WebIM.config.isMultiLoginSessions
			});

			my.conn.listen({
				onOpened: function(message) { //连接成功回调 
					com.dataCom.set("accessToken" + my.from, message.accessToken);
					my.conn.setPresence(); //设置在线状态
				},
				onClosed: function(message) {
					com.loadingClose();
				}, //连接关闭回调
				onTextMessage: function(message) {
					console.log(message);
					console.log("IM返回文本数据：" + JSON.stringify(message));
					if(!message.error) {
						//debugger; 
						var keyid = message.to;
						if(message.type == "groupchat") {
							keyid = message.to;
						} else {
							keyid = message.from;
						}
						var itemdata = {
							id: message.id,
							to: message.from,
							text: "",
							audiopath: "",
							imgurl: "",
							thimgurl: "",
							base64data: "",
							type: "text",
							chattype: message.type,
							time: my.getNowFormatDate(),
						};
						try {
							var revMsg = JSON.parse(message.data);
							itemdata.type = revMsg.type;
							itemdata.headimgurl = revMsg.headimgurl;

							//文字
							itemdata.text = revMsg.text || "";

							//图片
							itemdata.imgurl = revMsg.imgurl;
							itemdata.thimgurl = revMsg.thimgurl;

							//音频
							//itemdata.audiopath = revMsg.audiopath; 
							itemdata.base64data = revMsg.base64data;

							if(revMsg.time) {
								itemdata.time = revMsg.time;
							}
						} catch(err) {

						}
						if(revMsg.type == "audio" && itemdata.base64data) {
							my.dataURL2Audio(itemdata.base64data, function(entity) {
								itemdata.audiopath = entity.toURL();
								if(my.onTextMessage) {
									my.onTextMessage(keyid, itemdata);
								}
								my.setlocaldata(keyid, itemdata); //接收到消息存入緩存	本地存储; 
							});

						} else {
							if(my.onTextMessage) {
								my.onTextMessage(keyid, itemdata);
							}
							//接收到消息存入緩存	
							my.setlocaldata(keyid, itemdata); //接收到消息存入緩存	本地存储; 
						}

					}
				}, //收到文本消息
				onEmojiMessage: function(message) {
					console.log("IM返回表情数据：" + JSON.stringify(message));
				}, //收到表情消息
				onPictureMessage: function(message) {
					console.log("IM返回图片数据：" + JSON.stringify(message));
				}, //收到图片消息
				onCmdMessage: function(message) {
					console.log("IM返回命令数据：" + JSON.stringify(message));
				}, //收到命令消息
				onAudioMessage: function(message) {
					console.log("IM返回音频数据：" + JSON.stringify(message));
				}, //收到音频消息
				onLocationMessage: function(message) {
					console.log("IM返回位置据：" + JSON.stringify(message));
				}, //收到位置消息
				onFileMessage: function(message) {}, //收到文件消息
				onVideoMessage: function(message) {}, //收到视频消息
				onPresence: function(message) {}, //收到联系人订阅请求、处理群组、聊天室被踢解散等消息
				onRoster: function(message) {}, //处理好友申请
				onInviteMessage: function(message) {}, //处理群组邀请
				onOnline: function() {
					console.log("本机网络连接成功：");
				}, //本机网络连接成功
				onOffline: function() {
					console.log("本机网络掉线：");
				}, //本机网络掉线
				onError: function(message) {
					com.loadingClose();
					console.log("发送异常：" + JSON.stringify(message));
				}, //失败回调 
			});
			var userInfo = com.getUserInfo();
			console.log("当前登录人：" + userInfo.UserID);
			my.from = userInfo.UserID;
			my.headimgurl = userInfo.HeadImgUrl;
		},
		login: function() {
			var my = this;
			console.log("登录........" + my.from);
			var accessToken = com.dataCom.get("accessToken" + my.from);
			if(accessToken && accessToken != "undefined") {
				my.conn.open({
					apiUrl: WebIM.config.apiURL,
					user: my.from,
					accessToken: accessToken,
					appKey: WebIM.config.appkey
				});
			} else {
				my.conn.open({
					apiUrl: WebIM.config.apiURL,
					user: my.from,
					pwd: '0158AFAB-1061-4CA7-95E3-489A75F38E7F',
					appKey: WebIM.config.appkey
				});
			}

		},
		checkOnline: function() {
			if(this.conn == null) {
				this.connection();
			}
			this.login();
		},
		setlocaldata: function(signkey, data) {
			var my = this;
			if(data.type == "audio" && data.audiopath && data.base64data) {
				data.base64data = ""; //存储前先base64data清空
			}
			signkey = (my.from + signkey).toLowerCase();
			var mainkey = ("myfrendDatas" + my.from).toLowerCase();
			var myfrendDatasstr = com.dataCom.get(mainkey);

			console.log("存储键：" + signkey);
			var myfrendDatas = myfrendDatasstr == null ? {} : JSON.parse(myfrendDatasstr);
			if(myfrendDatas[signkey]) {
				if(myfrendDatas[signkey].length > 100) {
					myfrendDatas[signkey].splice(0, 1);
				}
				myfrendDatas[signkey].push(data);
			} else {
				myfrendDatas[signkey] = [data];
			}
			com.dataCom.set(mainkey, JSON.stringify(myfrendDatas));
		}, //添加缓存/修改
		getlocaldata: function(signkey) {
			var my = this;
			signkey = (my.from + signkey).toLowerCase();
			var mainkey = ("myfrendDatas" + my.from).toLowerCase();
			var myfrendDatasstr = com.dataCom.get(mainkey);

			var myfrendDatas = myfrendDatasstr == null ? {} : JSON.parse(myfrendDatasstr);
			if(myfrendDatasstr && myfrendDatas[signkey]) {
				return myfrendDatas[signkey];
			} else {
				return []
			}
		}, //添加缓存/修改
		getLastRecord: function() {
			var my = this;
			var lastRecordDatasstr = com.dataCom.get("lastRecord" + my.from);

			return lastRecordDatasstr == null ? {} : JSON.parse(lastRecordDatasstr);

		}, //获取最后聊天记录
		setLastRecord: function(data) {
			var my = this;
			if(data.type == "audio" && data.audiopath && data.base64data) {
				data.base64data = ""; //存储前先base64data清空
			}
			var lastRecordDatasstr = com.dataCom.get("lastRecord" + my.from);
			var lastRecordDatas = lastRecordDatasstr == null ? [] : JSON.parse(lastRecordDatasstr);

			var existIndex = -1;
			$.each(lastRecordDatas, function(i, item) {
				if(item.keyid == data.keyid) {
					existIndex = i;
				}
				return existIndex < 0;
			});

			if(existIndex >= 0) {
				lastRecordDatas.splice(existIndex, 1);
			}
			lastRecordDatas.splice(0, 0, data);
			com.dataCom.set("lastRecord" + my.from, JSON.stringify(lastRecordDatas));
		}, //设置最后聊天记录
		clearRecord: function(userid, signkey) {
			var my = this;
			//清理最后一次记录
			var lastRecordDatasstr = com.dataCom.get("lastRecord" + userid);
			var lastRecordDatas = lastRecordDatasstr == null ? {} : JSON.parse(lastRecordDatasstr);

			var existIndex = -1;
			$.each(lastRecordDatas, function(i, item) {
				if(item.keyid == signkey) {
					existIndex = i;
				}
				return existIndex < 0;
			});
			if(existIndex >= 0) {
				lastRecordDatas.splice(existIndex, 1);
			}
			com.dataCom.set("lastRecord" + userid, JSON.stringify(lastRecordDatas));

			//清理聊天记录 
			signkey = (userid + signkey).toLowerCase();
			var mainkey = ("myfrendDatas" + userid).toLowerCase();
			var myfrendDatasstr = com.dataCom.get(mainkey);

			var myfrendDatas = myfrendDatasstr == null ? {} : JSON.parse(myfrendDatasstr);
			if(myfrendDatas[signkey]) {
				delete myfrendDatas[signkey];
			}
			com.dataCom.set(mainkey, JSON.stringify(myfrendDatas));

		}, //设置最后聊天记录
		sendText: function(options, callback) {

			var my = this;
			var id = my.conn.getUniqueId(); // 生成本地消息id 
			var msg = new WebIM.message('txt', id); // 创建文本消息
			var sendmsgdata = $.extend({
				from: my.from,
				headimgurl: my.headimgurl
			}, options);

			msg.set({
				msg: JSON.stringify(sendmsgdata), // 消息内容 
				to: options.to, // 接收消息对象（用户id） 
				roomType: false,
				success: function(id, serverMsgId) {
					var data = $.extend({
						chattype: "singleChat",
						id: id,
						from: my.from,
						headimgurl: my.headimgurl
					}, options);
					if(callback) {
						callback(data);
					}
					my.setlocaldata(options.to, data); //本地存储;
				}
			});
			msg.body.chatType = 'singleChat';
			my.conn.send(msg.body);
		},
		sendGroupText: function(options, callback) {
			var my = this;
			var id = my.conn.getUniqueId(); // 生成本地消息id
			var msg = new WebIM.message('txt', id); // 创建文本消息

			var sendmsgdata = $.extend({
				from: my.from,
				headimgurl: my.headimgurl
			}, options);
			var option = {
				msg: JSON.stringify(sendmsgdata), // 消息内容
				to: options.to, // 接收消息对象(群组id)  
				roomType: false,
				chatType: 'chatRoom',
				success: function(id, serverMsgId) {
					var data = $.extend({
						chattype: "groupchat",
						id: id,
						from: my.from,
						headimgurl: my.headimgurl
					}, options);

					if(callback) {
						callback(data);
					}
					my.setlocaldata(options.to, data); //本地存储;
				},
				fail: function() {
					console.log('发送失败');
				}
			};
			msg.set(option);
			msg.setGroup('groupchat');
			my.conn.send(msg.body);
		},

	};

});