//touche.js
(function() {
	var isTouchDevice = navigator.userAgent.match(/(iPhone|iPod|iPad|Android|playbook|silk|BlackBerry|BB10|Windows Phone|Tizen|Bada|webOS|IEMobile|Opera Mini)/);
	if(isTouchDevice) { return }
	var isMouseDown = false,
		originator, fireTouch, mousedown, mousemove, mouseup;
	fireTouch = function(type, e) {
		var target, newEvent, touchesObj;
		target = originator || e.target;
		newEvent = document.createEvent("MouseEvent");
		newEvent.initMouseEvent(type, true, true, window, e.detail, e.screenX, e.screenY, e.clientX, e.clientY, e.ctrlKey, e.shiftKey, e.altKey, e.metaKey, e.button, e.relatedTarget);
		touchesObj = [{ identifier: (new Date()).getTime(), pageX: e.pageX, pageY: e.pageY, clientX: e.clientX, clientY: e.clientY, target: target, screenX: e.screenX, screenY: e.screenY }];
		switch(type) {
			case "touchstart":
				originator = target;
				newEvent.touches = newEvent.changedTouches = newEvent.targetTouches = touchesObj;
				break;
			case "touchmove":
				newEvent.touches = newEvent.changedTouches = newEvent.targetTouches = touchesObj;
				break;
			case "touchend":
				originator = null;
				newEvent.changedTouches = touchesObj;
				newEvent.touches = newEvent.targetTouches = [];
				break;
			default:
				break
		}
		e.target.dispatchEvent(newEvent)
	};
	mousedown = function(e) {
		isMouseDown = true;
		fireTouch("touchstart", e)
	};
	mousemove = function(e) { if(!isMouseDown) { return } fireTouch("touchmove", e) };
	mouseup = function(e) {
		isMouseDown = false;
		fireTouch("touchend", e)
	};
	document.addEventListener("mousedown", mousedown, false);
	document.addEventListener("mousemove", mousemove, false);
	document.addEventListener("mouseup", mouseup, false);
	window.ontouchstart = mousedown;
	window.ontouchmove = mousemove;
	window.ontouchend = mouseup
})();

/**
 * @下拉刷新
 * 善有部分不完善之处，后续稍稍进行扩展
 */
(function() {
	var isValid = false,
		isTouching = false,
		isEfec = false,
		isDestory = false,
		startX, startY, disY = 0,
		loadingH = 0,
		options = {
			$el: $("body"),
			$loadingEl: null,
			autoHide: true,
			url: undefined,
			sendData: null,
			startPX: 50,
			callbacks: {
				pullStart: null,
				start: null,
				success: null,
				error: null,
				end: null,
			}
		};
	var getPos = function(event) {
		var pos = {
			x: event.pageX || event.clientX,
			y: event.pageY || event.clientY
		};
		return pos
	};
	var reset = function(isAnim, time) {
		isValid = false, isEfec = false, startX, startY, disY = 0;
		setTimeout(function() {
			options.$loadingEl.animate({
				"margin-top": -loadingH
			}, (isAnim == false ? 0 : 800), function() {
				isTouching = false;
				runCb("end")
			})
		}, time ? time : 1000);
	};
	var touchStart = function(evt) {
		var scrollTop = parseInt($("body").scrollTop());
		if(scrollTop > 0) {
			isEfec = false
		} else {
			isEfec = true
		}
		var touch = evt.touches[0],
			x = parseInt(touch.pageX),
			y = parseInt(touch.pageY);
		startX = x;
		startY = y
	};
	var touchMove = function(evt) {
		if(!isEfec) {
			return
		}
		var $loadingEl = options.$loadingEl,
			touch = evt.touches[0],
			x = parseInt(touch.pageX),
			y = parseInt(touch.pageY),
			t = y - startY;
		if(!isValid && t > options.startPX) {
			isValid = true;
			runCb("pullStart")
		}
		if(!isValid) {
			return
		}
		if(evt.preventDefault) {
			evt.preventDefault()
		}
		if(t < 0) {
			$loadingEl.css("margin-top", -loadingH)
		}
		if(t > 0 && t <= loadingH) {
			$loadingEl.css("margin-top", -(loadingH - t));
			$loadingEl.height(loadingH)
		} else {
			if(t > loadingH) {
				$loadingEl.css("margin-top", 0);
				if(t > 100) {
					t = 100
				}
				$loadingEl.height(t)
			}
		}
		disY = t
	};
	var touchEnd = function(evt) {
		if(!isEfec) {
			return
		}
		if(isDestory) {
			return
		}
		if(!isValid) {
			return
		}
		if(isTouching) {
			return
		}
		if(evt.preventDefault) {
			evt.preventDefault()
		}
		isValid = false;
		isEfec = false;
		disY = 0;
		var $loadingEl = options.$loadingEl,
			touch = evt.touches[0] || evt.changedTouches[0],
			x = parseInt(touch.pageX),
			y = parseInt(touch.pageY),
			t = y - startY;
		if(t <= loadingH) {
			$loadingEl.css("margin-top", -(loadingH - t));
			$loadingEl.height(loadingH);
			$loadingEl.animate({
				"margin-top": -loadingH
			}, 200, function() {
				isTouching = false
			})
		} else {
			if(t > loadingH) {
				if(options.cb) {
					options.cb()
				}
				$loadingEl.animate({
					"height": loadingH
				}, 200, function() {})
			}
		}
		var sendData = $.isFunction(options.sendData) ? options.sendData() : options.sendData;
		runCb("start");
		if(options.url) {
			$.post(options.url, sendData, function(response, textStatus, xhr) {
				runCb("success", response);
				if(options.autoHide) {
					reset()
				}
			}).error(function() {
				runCb("error");
				if(options.autoHide) {
					reset()
				}
			})
		} else {
			if(options.callbacks) {
				reset()
			}
		}
	};
	var runCb = function(name, data) {
		if(options.callbacks[name]) {
			options.callbacks[name].call(null, data)
		}
	};
	var setDestroy = function(destroy) {
		isDestory = destroy || false
	};
	var initlize = function() {
		loadingH = options.$loadingEl.height();
		$el = options.$el;
		$el[0].addEventListener("touchstart", touchStart, false);
		$el[0].addEventListener("touchmove", touchMove, false);
		$el[0].addEventListener("touchend", touchEnd, false)
	};
	var pullDown = function() {
		initlize();
		return {
			reset: reset,
			setDestroy: setDestroy
		}
	};
	$.pPullRefresh = function(settings) {
		$.extend(true, options, (settings || {}));
		options.$el = options.$el || $("body");
		return pullDown(settings)
	};
	$.fn.pPullRefresh = function(settings) {
		settings.$el = $(this);
		return $.pPullRefresh(settings)
	}
})();

/*
 init
 * */
var pullRefresh = {
	down: function(callback) {
		var html = '<style>.loading-warp{display:table;width:100%;margin-top:-100px;height:100px;background:#fff;}.loading-warp .box{width:100%;display:table-cell;text-align:center;vertical-align:middle}</style><div class="loading-warp"><div class="box"><span class="gif-loading"></span></div></div>';
		if($("header").length > 0) {
			$(".mui-content").prepend(html)
		} else {
			$("body").prepend(html)
		};
		//
		var $statu = $(".loading-warp .text");
		var pullRefresh = $(".mui-content").pPullRefresh({
			$el: $(".mui-content"),
			$loadingEl: $(".loading-warp"),
			sendData: null,
			autoHide: true,
			url: "",
			callbacks: {
				pullStart: function() {},
				start: function() {
					if(callback) {
						callback()
					}
				},
				success: function(response) {},
				end: function() {
					if(!callback) {
						location.reload()
					}
				},
				error: function(e) {
					console.log(e)
				}
			}
		})
	},
	//上拉刷新
	up: function(callback, ele) {
		document.addEventListener("dragend", function(e) {
			if(e.detail.direction == 'up') {
				var scrollTop = $(this).scrollTop();
				var scrollHeight = $(document).height();　　
				var windowHeight = $(window).height();　
				var beforeHeight = windowHeight; //提前多少高度加载
				if(scrollTop + windowHeight + beforeHeight >= scrollHeight) {
					ele.fadeIn();
//					setTimeout(function(){
//						ele.fadeOut();
//					},500)
					//$(window).scrollTop(999999);
					if(callback)
						callback();
				}
			}
		});
	},
};